using System.Net.Mime;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using Library;
using System.Net;
using System.IO;
using Aop.Api.Util;
using LitJson;

namespace MySystem
{
    public class TestHaoDaHelper
    {
        public readonly static TestHaoDaHelper Instance = new TestHaoDaHelper();
        private TestHaoDaHelper()
        {
        }

        #region 盒易付

        //测试环境
        // string BoxRequestUrl = "https://openapi-test.iboxpay.com";
        // string BoxAppId = "AT7317781468267548672";
        // string BoxAppSecret = "OfWuHQdhQfnE8NaF4xdtgk4B9CYqnbri";
        // string BoxPublicKey = "";
        // string BrhCode = "001040";

        //生产环境
        string BoxRequestUrl = "https://openapi.iboxpay.com";
        string BoxAppId = "AP7175619323825451008";
        string BoxAppSecret = "hUfR53gdjyfiZTBR5bILanMqRD1dXD7y";
        string BoxPublicKey = "";
        public static string BrhCode = "030145";

        /// <summary>
        /// 商户修改银行卡
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        public string ChangeMerchantCard(ChangeMerchantCard request)
        {
            LogHelper.Instance.WriteLog(DateTime.Now.ToString(), "好哒商户修改银行卡");

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(request);
            LogHelper.Instance.WriteLog(req, "好哒商户修改银行卡");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            LogHelper.Instance.WriteLog("请求头\n" + head, "好哒商户修改银行卡");
            LogHelper.Instance.WriteLog("请求参数\n" + req, "好哒商户修改银行卡");
            LogHelper.Instance.WriteLog("请求地址：" + BoxRequestUrl + "/api/inst/mcht/update_acct", "好哒商户修改银行卡");
            string result = PostWebRequest(BoxRequestUrl + "/api/inst/mcht/update_acct", req, headdic);
            LogHelper.Instance.WriteLog("返回\n" + result + "\n\n", "好哒商户修改银行卡");

            return result;
        }

        /// <summary>
        /// 查询修改银行卡任务审核状态
        /// </summary>
        /// <param name="mchtNo">收款商户号</param>
        /// <param name="taskId">任务id</param>
        /// <returns></returns>
        public string QueryChangeCardStatus(string mchtNo, string taskId)
        {
            LogHelper.Instance.WriteLog(DateTime.Now.ToString(), "好哒查询修改银行卡任务审核状态");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            reqdic.Add("mchtNo", mchtNo);
            reqdic.Add("taskId", taskId);

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            LogHelper.Instance.WriteLog(req, "好哒查询修改银行卡任务审核状态");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            LogHelper.Instance.WriteLog("请求头\n" + head, "好哒查询修改银行卡任务审核状态");
            LogHelper.Instance.WriteLog("请求参数\n" + req, "好哒查询修改银行卡任务审核状态");
            LogHelper.Instance.WriteLog("请求地址：" + BoxRequestUrl + "/api/inst/mcht/query_acct_task", "好哒查询修改银行卡任务审核状态");
            string result = PostWebRequest(BoxRequestUrl + "/api/inst/mcht/query_acct_task", req, headdic);
            LogHelper.Instance.WriteLog("返回\n" + result + "\n\n", "好哒查询修改银行卡任务审核状态");

            return result;
        }

        /// <summary>
        /// 订单分账申请
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        /// 
        public string OrderDivideAccounts22()
        {
            LogHelper.Instance.WriteLog(DateTime.Now.ToString(), "好哒订单分账申请");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            List<Dictionary<string, object>> list = new List<Dictionary<string, object>>();
            Dictionary<string, object> lists = new Dictionary<string, object>();
            lists = new Dictionary<string, object>();
            reqdic.Add("applyNo", "FZ202309070001");
            reqdic.Add("mchtNo", "1475762");
            reqdic.Add("orderNo", "G2230907C01986946066");
            lists.Add("acctNo", "230817000000000278");
            lists.Add("acctType", "1");
            lists.Add("amount", "100");
            list.Add(lists);

            lists = new Dictionary<string, object>();
            lists.Add("acctNo", "030510106621391");
            lists.Add("acctType", "0");
            lists.Add("amount", "9862");
            list.Add(lists);

            reqdic.Add("detail", list);
            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            LogHelper.Instance.WriteLog(req, "好哒订单分账申请");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            LogHelper.Instance.WriteLog("请求头\n" + head, "好哒订单分账申请");
            LogHelper.Instance.WriteLog("请求参数\n" + req, "好哒订单分账申请");
            LogHelper.Instance.WriteLog("请求地址：" + BoxRequestUrl + "/api/v3/hzg/part/order/apply", "好哒订单分账申请");
            string result = PostWebRequest(BoxRequestUrl + "/api/v3/hzg/part/order/apply", req, headdic);
            LogHelper.Instance.WriteLog("返回\n" + result + "\n\n", "好哒订单分账申请");

            return result;
        }

        /// <summary>
        /// 分账交易详情查询
        /// </summary>
        /// <param name="mchtNo">慧掌柜商户号</param>
        /// <param name="orderNo">交易订单号	</param>
        /// <returns></returns>
        public string QueryOrderDivideAccountsss()
        {
            LogHelper.Instance.WriteLog(DateTime.Now.ToString(), "好哒分账交易详情查询");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            reqdic.Add("mchtNo", "1475762"); // 慧掌柜商户号
            reqdic.Add("orderNo", "G2230907C01986946066"); // 交易订单号	
            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            LogHelper.Instance.WriteLog(req, "好哒分账交易详情查询");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            LogHelper.Instance.WriteLog("请求头\n" + head, "好哒分账交易详情查询");
            LogHelper.Instance.WriteLog("请求参数\n" + req, "好哒分账交易详情查询");
            LogHelper.Instance.WriteLog("请求地址：" + BoxRequestUrl + "/api/v3/hzg/part/trade/clear/get", "好哒分账交易详情查询");
            string result = PostWebRequest(BoxRequestUrl + "/api/v3/hzg/part/trade/clear/get", req, headdic);
            LogHelper.Instance.WriteLog("返回\n" + result + "\n\n", "好哒分账交易详情查询");

            return result;
        }

        /// <summary>
        /// 聚合支付退款接口
        /// </summary>
        /// <param name="mchtNo">盒子的商户编号</param>
        /// <param name="storeNo">盒子的门店编号</param>
        /// <param name="outRefundNo">商户退款订单号</param>
        /// <param name="outOrderNo">商户支付订单号</param>
        /// <param name="refundAmount">退款金额，单位：分</param>
        /// <returns></returns>
        public string AggregatedPayRefundsss()
        {
            LogHelper.Instance.WriteLog(DateTime.Now.ToString(), "好哒聚合支付退款");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();

            reqdic.Add("mchtNo", "1475762"); // 盒子的商户编号	
            reqdic.Add("storeNo", "21604555"); // 盒子的门店编号	
            reqdic.Add("outRefundNo", "9335533180636825300395666888"); //32 商户退款订单号	
            reqdic.Add("outOrderNo", "2023090715460060997601022"); // 商户支付订单号	
            reqdic.Add("refundAmount", "502"); //10 退款金额，单位：分
            reqdic.Add("refundReason", "门店消费补贴"); //退款原因(仅微信交易且退款金额大于1元时在退款消息中展示)

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            LogHelper.Instance.WriteLog(req, "好哒聚合支付退款");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            LogHelper.Instance.WriteLog("请求头\n" + head, "好哒聚合支付退款");
            LogHelper.Instance.WriteLog("请求参数\n" + req, "好哒聚合支付退款");
            LogHelper.Instance.WriteLog("请求地址：" + BoxRequestUrl + "/api/hzg/v2/unitedtrade/refund", "好哒聚合支付退款");
            string result = PostWebRequest(BoxRequestUrl + "/api/hzg/v2/unitedtrade/refund", req, headdic);
            LogHelper.Instance.WriteLog("返回\n" + result + "\n\n", "好哒聚合支付退款");

            return result;
        }

        public Dictionary<string, string> GetHeader(string req)
        {
            Dictionary<string, string> headdic = new Dictionary<string, string>();
            string timestamp = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            // headdic.Add("appid", BoxAppId);//开发者id
            // headdic.Add("appsecret", BoxAppSecret);//开发者密码
            headdic.Add("X-Up-AppId", BoxAppId);
            headdic.Add("X-Timestamp", timestamp);
            headdic.Add("X-Sign-Type", "SHA-256");
            headdic.Add("X-Sign", SHA256Sign(timestamp + BoxAppSecret + req));
            return headdic;
        }

        public string SHA256Sign(string toSignStr)
        {
            byte[] toSignByte = Encoding.UTF8.GetBytes(toSignStr);
            SHA256 sha256 = SHA256.Create();
            byte[] signByte = sha256.ComputeHash(toSignByte);
            string sign = Convert.ToBase64String(signByte);
            return sign;
        }

        public bool VerifySign(string toSignStr, string signStr)
        {
            byte[] toSignByte = Encoding.Default.GetBytes(toSignStr);
            byte[] signByte = Convert.FromBase64String(signStr);
            var toKey = Convert.FromBase64String(BoxPublicKey);
            var rsaroot = RSA.Create();
            rsaroot.ImportSubjectPublicKeyInfo(toKey, out _);
            var publicKeyParameters = rsaroot.ExportParameters(false);
            using (var rsa = RSA.Create())
            {
                rsa.ImportParameters(publicKeyParameters);
                var sha256 = SHA256.Create();
                var hash = sha256.ComputeHash(toSignByte);
                return rsa.VerifyHash(hash, signByte, HashAlgorithmName.SHA256, RSASignaturePadding.Pkcs1);
            }
        }

        public string SignData(string toSignStr)
        {
            byte[] toSignByte = Encoding.UTF8.GetBytes(toSignStr);
            var toKey = Convert.FromBase64String(BoxPublicKey);
            var rsaroot = RSA.Create();
            rsaroot.ImportSubjectPublicKeyInfo(toKey, out _);
            var publicKeyParameters = rsaroot.ExportParameters(false);
            using (var rsa = RSA.Create())
            {
                rsa.ImportParameters(publicKeyParameters);
                var sha256 = SHA256.Create();
                var hash = sha256.ComputeHash(toSignByte);
                byte[] endByte = rsa.SignData(toSignByte, HashAlgorithmName.SHA256, RSASignaturePadding.Pkcs1);
                return Convert.ToBase64String(endByte);
            }
        }

        private string PostWebRequest(string postUrl, string paramData, Dictionary<string, string> headers)
        {
            string ret = string.Empty;
            try
            {
                LogHelper.Instance.WriteLog(DateTime.Now.ToString(), "请求好哒API日志");
                LogHelper.Instance.WriteLog(postUrl, "请求好哒API日志");
                LogHelper.Instance.WriteLog(paramData, "请求好哒API日志");
                byte[] postData = System.Text.Encoding.UTF8.GetBytes(paramData);
                // 设置提交的相关参数 
                System.Net.HttpWebRequest request = System.Net.WebRequest.Create(postUrl) as System.Net.HttpWebRequest;
                System.Text.Encoding myEncoding = System.Text.Encoding.UTF8;
                request.Method = "POST";
                request.KeepAlive = false;
                request.AllowAutoRedirect = true;
                request.ContentType = "application/json";
                foreach (string key in headers.Keys)
                {
                    request.Headers.Add(key, headers[key]);
                }
                request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR  3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)";

                request.ContentLength = postData.Length;

                // 提交请求数据 
                System.IO.Stream outputStream = request.GetRequestStream();
                outputStream.Write(postData, 0, postData.Length);
                outputStream.Close();
                System.Net.HttpWebResponse response;
                System.IO.Stream responseStream;
                System.IO.StreamReader reader;
                string srcString;
                response = request.GetResponse() as System.Net.HttpWebResponse;
                responseStream = response.GetResponseStream();
                reader = new System.IO.StreamReader(responseStream, System.Text.Encoding.UTF8);
                srcString = reader.ReadToEnd();
                ret = srcString;   //返回值赋值
                reader.Close();
                LogHelper.Instance.WriteLog(srcString, "请求好哒API日志");
            }
            catch (System.Net.WebException ex)
            {
                System.Net.HttpWebResponse response = (System.Net.HttpWebResponse)ex.Response;
                System.IO.Stream myResponseStream = response.GetResponseStream();
                //获取响应内容
                System.IO.StreamReader myStreamReader = new System.IO.StreamReader(myResponseStream);
                ret = myStreamReader.ReadToEnd();
                myResponseStream.Close();
            }
            catch (Exception ex)
            {
                ret = "fail";
                LogHelper.Instance.WriteLog(DateTime.Now.ToString() + "\r\n" + ex.ToString(), "请求好哒API异常");
            }
            return ret;
        }

        /// <summary>
        /// 获取文件令牌接口
        /// </summary>
        /// <param name="fileName">文件名</param>
        /// <param name="action">操作类型 0 上传图片</param>
        /// <returns></returns>
        public string GetToken(string fileName, string action)
        {
            LogHelper.Instance.WriteLog(DateTime.Now.ToString(), "好哒获取文件令牌接口");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();

            reqdic.Add("fileName", fileName); // 文件名	
            reqdic.Add("action", action); // 操作类型 0 上传图片

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            LogHelper.Instance.WriteLog(req, "好哒获取文件令牌接口");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            LogHelper.Instance.WriteLog("请求头\n" + head, "好哒获取文件令牌接口");
            LogHelper.Instance.WriteLog("请求参数\n" + req, "好哒获取文件令牌接口");
            LogHelper.Instance.WriteLog("请求地址：" + BoxRequestUrl + "/api/auth/v1/get_file_token", "好哒获取文件令牌接口");
            string result = PostWebRequest(BoxRequestUrl + "/api/auth/v1/get_file_token", req, headdic);
            LogHelper.Instance.WriteLog("返回\n" + result + "\n\n", "好哒获取文件令牌接口");

            return result;
        }

        /// <summary>
        /// 执行带文件上传的HTTP POST请求。
        /// </summary>
        /// <param name="url">请求地址</param>
        /// <param name="textParams">请求文本参数</param>
        /// <param name="fileParams">请求文件参数</param>
        /// <param name="charset">编码字符集</param>
        /// <returns>HTTP响应</returns>
        public string DoPost(string url, string token, IDictionary<string, string> textParams, IDictionary<string, FileItem> fileParams, string charset = "utf-8")
        {
            // 如果没有文件参数，则走普通POST请求
            if (fileParams == null || fileParams.Count == 0)
            {
                return "";
            }

            string boundary = DateTime.Now.Ticks.ToString("X"); // 随机分隔线

            HttpWebRequest req = GetWebRequest(url, "POST");
            req.Headers.Add("X-File-Token", token);
            req.ContentType = "multipart/form-data;charset=" + charset + ";boundary=" + boundary;

            Stream reqStream = req.GetRequestStream();
            byte[] itemBoundaryBytes = Encoding.GetEncoding(charset).GetBytes("\r\n--" + boundary + "\r\n");
            byte[] endBoundaryBytes = Encoding.GetEncoding(charset).GetBytes("\r\n--" + boundary + "--\r\n");

            // 组装文本请求参数
            string textTemplate = "Content-Disposition:form-data;name=\"{0}\"\r\nContent-Type:text/plain\r\n\r\n{1}";
            IEnumerator<KeyValuePair<string, string>> textEnum = textParams.GetEnumerator();
            while (textEnum.MoveNext())
            {
                string textEntry = string.Format(textTemplate, textEnum.Current.Key, textEnum.Current.Value);
                byte[] itemBytes = Encoding.GetEncoding(charset).GetBytes(textEntry);
                reqStream.Write(itemBoundaryBytes, 0, itemBoundaryBytes.Length);
                reqStream.Write(itemBytes, 0, itemBytes.Length);
            }

            // 组装文件请求参数
            string fileTemplate = "Content-Disposition:form-data;name=\"{0}\";filename=\"{1}\"\r\nContent-Type:{2}\r\n\r\n";
            IEnumerator<KeyValuePair<string, FileItem>> fileEnum = fileParams.GetEnumerator();
            while (fileEnum.MoveNext())
            {
                string key = fileEnum.Current.Key;
                FileItem fileItem = fileEnum.Current.Value;
                string fileEntry = string.Format(fileTemplate, key, fileItem.GetFileName(), fileItem.GetMimeType());
                byte[] itemBytes = Encoding.GetEncoding(charset).GetBytes(fileEntry);
                reqStream.Write(itemBoundaryBytes, 0, itemBoundaryBytes.Length);
                reqStream.Write(itemBytes, 0, itemBytes.Length);

                byte[] fileBytes = fileItem.GetContent();
                reqStream.Write(fileBytes, 0, fileBytes.Length);
            }

            reqStream.Write(endBoundaryBytes, 0, endBoundaryBytes.Length);
            reqStream.Close();

            HttpWebResponse rsp = (HttpWebResponse)req.GetResponse();
            Encoding encoding = Encoding.GetEncoding(rsp.CharacterSet);
            return GetResponseAsString(rsp, encoding);
        }

        public HttpWebRequest GetWebRequest(string url, string method)
        {
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
            req.ServicePoint.Expect100Continue = false;
            req.Method = method;
            req.KeepAlive = true;
            req.Timeout = 100000;
            return req;
        }

        /// <summary>
        /// 把响应流转换为文本。
        /// </summary>
        /// <param name="rsp">响应流对象</param>
        /// <param name="encoding">编码方式</param>
        /// <returns>响应文本</returns>
        public string GetResponseAsString(HttpWebResponse rsp, Encoding encoding)
        {
            StringBuilder result = new StringBuilder();
            Stream stream = null;
            StreamReader reader = null;

            try
            {
                // 以字符流的方式读取HTTP响应
                stream = rsp.GetResponseStream();
                reader = new StreamReader(stream, encoding);

                // 按字符读取并写入字符串缓冲
                int ch = -1;
                while ((ch = reader.Read()) > -1)
                {
                    // 过滤结束符
                    char c = (char)ch;
                    if (c != '\0')
                    {
                        result.Append(c);
                    }
                }
            }
            finally
            {
                // 释放资源
                if (reader != null) reader.Close();
                if (stream != null) stream.Close();
                if (rsp != null) rsp.Close();
            }

            return result.ToString();
        }


        /// <summary>
        /// 获取好哒开放平台文件名
        /// </summary>
        /// <param name="token">上传图片凭证token</param>
        /// <param name="value">图片路径</param>
        /// <returns></returns>
        public string ReturnFileName(string token, string value)
        {
            Dictionary<string, string> file = new Dictionary<string, string>();
            file.Add("fileName", value.Substring(value.LastIndexOf("/")).Trim('/'));
            if (string.IsNullOrEmpty(value.Split(',')[0]))
            {
                return "";
            }
            FileItem item = new FileItem(function.getPath(value.Split(',')[0]));
            Dictionary<string, FileItem> files = new Dictionary<string, FileItem>();
            files.Add("file", item);
            var upLoadInfo = JsonMapper.ToObject(HaoDaHelper.Instance.DoPost(BoxRequestUrl + "/api/file/v1/upload_file", token, file, files, "utf-8"));
            if (upLoadInfo["code"].ToString() == "1")
            {
                return upLoadInfo["data"]["fileName"].ToString();
            }
            else
            {
                return "false";
            }
        }

        #endregion

    }
}